# `garrettmills/gcdt`
## Musings on Generalized Commutative Data Types

A “commutative data type” is one whose value is modified by a set of operations whose execution order is irrelevant. Such data types are useful in distributed & parallel systems which employ accumulator-style execution (i.e. many jobs perform a calculation then merge their result into a single, shared value).

This repo contains my writings and miscellaneous models for these data-types.

## Table of Contents

- `doc` - Blog-posts & write-ups in Markdown format
- `alloy` - GCDT models & theorems for the Alloy model checker

## License

 <p xmlns:cc="http://creativecommons.org/ns#" ><a rel="cc:attributionURL" href="https://code.garrettmills.dev/garrettmills/gcdt">This work</a> by <a rel="cc:attributionURL dct:creator" property="cc:attributionName" href="https://garrettmills.dev/">Garrett Mills</a> is licensed under <a href="http://creativecommons.org/licenses/by-nc-sa/4.0/?ref=chooser-v1" target="_blank" rel="license noopener noreferrer" style="display:inline-block;">CC BY-NC-SA 4.0</a></p>
